﻿////////////////////////////////////////
/// Code by: Mike Krell                          ///
/// Copywrite: Fundy Software 2013   ///
/// For: Jerry Ghionis                           ///
///////////////////////////////////////

var inputFolder = Folder.selectDialog("Please select your images folder");
var outputFolder = Folder.selectDialog("Now select your output folder");
var filelist= inputFolder.getFiles (/\.(jpg|psd|png)$/i);
for (i=0; i< filelist.length; i++){
    resizeToAllSizes (filelist[i], outputFolder);
    }
alert( "Done resizing");

function resizeToAllSizes (inputFile, outputPath) {
    open(inputFile)
    var width = app.activeDocument.width 
    var height = app.activeDocument.height
    var fileName = activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.'));
    var iphone5 = [1920, 1920, "Resized"];
    var phones = [iphone5]
    for (a=0; a<phones.length;a++){
        for (b=0; b<phones[a].length; b++){
            var output = new Folder (outputPath + "/" + phones[a][2]);
                if (!output.exists) {
                    output.create()
                }
            var newFile = new File (output.fsName + "/" + fileName + ".jpeg");
            if (width > height) {
                    resizeToFit (phones[a][1], phones[a][0])
                }
            else if ( height > width ) {
                    resizeToFit (phones[a][0], phones[a][1] )
                }
              else {
                    resizeToFit (phones[a][0], phones[a][1] )
                  }
            changeDPI (72);
            SaveJPEG (newFile, 12);
            undoResize ();
            } 
        }
    activeDocument.close (SaveOptions.DONOTSAVECHANGES)
    }

function resizeToFit(height, width){
var idthreecaathreefourthreefourcbsixsevenoneonedonebcfourthreezerozerosixzerobzeroaonethreedcfour = stringIDToTypeID( "3caa3434-cb67-11d1-bc43-0060b0a13dc4" );
    var desc37 = new ActionDescriptor();
    var idMsge = charIDToTypeID( "Msge" );
    desc37.putString( idMsge, "Fit Image action settings" );
    var idHght = charIDToTypeID( "Hght" );
    var idPxl = charIDToTypeID( "#Pxl" );
    desc37.putUnitDouble( idHght, idPxl, height );
    var idWdth = charIDToTypeID( "Wdth" );
    var idPxl = charIDToTypeID( "#Pxl" );
    desc37.putUnitDouble( idWdth, idPxl, width );
    var idlimit = stringIDToTypeID( "limit" );
    desc37.putBoolean( idlimit, true );
executeAction( idthreecaathreefourthreefourcbsixsevenoneonedonebcfourthreezerozerosixzerobzeroaonethreedcfour, desc37, DialogModes.NO );
}

function SaveJPEG(saveFile, jpegQuality){
    jpgSaveOptions = new JPEGSaveOptions();
    jpgSaveOptions.embedColorProfile = true;
    jpgSaveOptions.formatOptions = FormatOptions.STANDARDBASELINE;
    jpgSaveOptions.matte = MatteType.NONE;
    jpgSaveOptions.quality = jpegQuality; //1-12
    activeDocument.saveAs(saveFile, jpgSaveOptions, true,Extension.LOWERCASE);
}

function changeDPI (dpi) {
var idImgS = charIDToTypeID( "ImgS" );
    var desc1045 = new ActionDescriptor();
    var idRslt = charIDToTypeID( "Rslt" );
    var idRsl = charIDToTypeID( "#Rsl" );
    desc1045.putUnitDouble( idRslt, idRsl, dpi );
executeAction( idImgS, desc1045, DialogModes.NO );    
    }

function undoResize(){
var idRvrt = charIDToTypeID( "Rvrt" );
executeAction( idRvrt, undefined, DialogModes.NO );
    }